/*
codr: timiter
task: add
lang: C++
*/

#include <cstdio>

using namespace std;

long long n, m, x = 0;
long long a[4][4] = { { 2, 1, 1 }, { 1, 0, 0 }, { 0, 1, 0 } };
long long b[4][4] = { { 1, 0, 0 }, { 0, 1, 0 }, { 0, 0, 1 } };
long long c[4] = { 13, 5, 2 }, d[4][4];

void dble();
void mult();

int main()
{
	int i;
	scanf("%lld %lld", &n, &m);
	if (n == 1)
	{
		printf("%lld\n", 2 % m);
		return 0;
	}
	if (n == 2)
	{
		printf("%lld\n", 5 % m);
		return 0;
	}
	if (n == 3)
	{
		printf("%lld\n", 13 % m);
		return 0;
	}
	n -= 3;
	while (n)
	{
		if (n % 2)
		{
			mult();
		}
		n /= 2;
		dble();
	}
	for (i = 0; i < 3; i++)
	{
		x = (x + (b[0][i] * c[i] % m)) % m;
	}
	printf("%lld\n", x);
    return 0;
}

void dble()
{
	int i, j, k;
	for (i = 0; i < 3; i++)
	{
		for (j = 0; j < 3; j++)
		{
			d[i][j] = 0;
			for (k = 0; k < 3; k++)
			{
				d[i][j] = (d[i][j] + (a[i][k] * a[k][j] % m)) % m;
			}
		}
		for (i = 0; i < 3; i++)
		{
			for (j = 0; j < 3; j++)
			{
				a[i][j] = d[i][j];
			}
		}
	}
}

void mult()
{
	int i, j, k;
	for (i = 0; i < 3; i++)
	{
		for (j = 0; j < 3; j++)
		{
			d[i][j] = 0;
			for (k = 0; k < 3; k++)
			{
				d[i][j] = (d[i][j] + (a[i][k] * b[k][j] % m)) % m;
			}
		}
	}
	for (i = 0; i < 3; i++)
	{
		for (j = 0; j < 3; j++)
		{
			b[i][j] = d[i][j];
		}
	}
}
