#include <iostream>
#include <queue>
using namespace std;

struct cube
{
       int x, y;
       int up, down, front, rear, left, right;
       int len, sum;
};

queue<cube> q;
int d[32][32], sum[32][32];

bool stava( int x, int y )
{
     if ( ( x >= 1 ) && ( x <= 26 ) && ( y >= 1 ) && ( y <= 26 ) && ( y >= 1 ) && ( y <= 26 ) && ( d[x][y] == -2 ) )
     {
        return true;
     }
     return false;
}

cube flipup( cube a )
{
     cube r;
     r.up = a.front; r.down = a.rear;
     r.front = a.down; r.rear = a.up;
     r.left = a.left; r.right = a.right;
     return r;
}

cube flipright( cube a )
{
     cube r;
     r.up = a.left; r.down = a.right;
     r.front = a.front; r.rear = a.front;
     r.left = a.down; r.right = a.up;
     return r;
}

cube flipdown( cube a )
{
     cube r;
     r.up = a.rear; r.down = a.front;
     r.front = a.up; r.rear = a.down;
     r.left = a.left; r.right = a.right;
     return r;
}

cube flipleft( cube a )
{
     cube r;
     r.up = a.right; r.down = a.left;
     r.front = a.front; r.rear = a.front;
     r.left = a.up; r.right = a.right;
     return r;
}

int main()
{
    cube a, b, c, t;
    int i, j, k, l, p;
    int bestlen = INT_MAX;
    int o6te[32][32];
    char x;
    
    cin.get( x );
    c.x = x - 'a' + 1;
    cin >> c.y;
    cin.get();
    
    cin.get( x );
    t.x = x - 'a' + 1;
    cin >> t.y;
    t.len = INT_MAX;
    t.sum = INT_MAX;
    
    cin >> c.front >> c.rear >> c.up >> c.right >> c.down >> c.left;
    c.sum = c.down;
    c.len = 0;
    
    for ( i = 1; i <= 26; i++ )
        for ( j = 1; j <= 26; j++ )
        {
            d[i][j] = -2;
            sum[i][j] = INT_MAX;
        }

    cin >> k;
    for ( i = 1; i <= k; i++ )
    {
        cin.get();
        cin.get( x );
        j = x - 'a' + 1;
        cin >> l;
        d[j][l] = -1;
    }
    
    if ( ( c.front == c.rear ) && ( c.rear == c.up ) && ( c.up == c.right ) && ( c.right == c.down ) && ( c.down == c.left ) )
    {
         if ( k == 0 )
         {
              cout << ( abs( t.x - c.x ) + abs( t.y - c.y ) + 1 ) * c.front << endl;
              return 0;
         }
    }
    
    d[c.x][c.y] = 0;
    
    q.push( c );
    while ( !q.empty() )
    {
        p = q.size();

        for ( i = 1; i <= 26; i++ )
            for ( j = 1; j <= 26; j++ )
                o6te[i][j] = d[i][j];
        
        if ( t.len != INT_MAX )
           break;
        for ( l = 0; l < p; l++ )
        {
           a = q.front();
           q.pop();
          
           if ( a.len > d[a.x][a.y] )
              continue;
           if ( a.len > t.len )
              break;
           if ( stava( a.x+1, a.y ) )
           {
                b = flipup( a );
                b.x = a.x + 1;
                b.y = a.y;
                b.len = a.len + 1;
                b.sum = a.sum + b.down;
                {
                   sum[b.x][b.y] = b.sum;
                   if ( ( b.x == t.x ) && ( b.y == t.y ) )
                   {
                     if ( b.len < t.len )
                     {
                          t.sum = b.sum;
                          t.len = b.len;
                     }
                     if ( b.len == t.len )
                        if ( b.sum < t.sum )
                           t.sum = b.sum;
                   }
                   q.push( b );
                   o6te[b.x][b.y] = b.len;
                }
//                cout << b.x << " " << b.y << " " << o6te[b.x][b.y] << endl;
           }

           if ( stava( a.x, a.y+1 ) )
           {
                b = flipright( a );
                b.x = a.x;
                b.y = a.y + 1;
                b.len = a.len + 1;
                b.sum = a.sum + b.down;
                {
                   sum[b.x][b.y] = b.sum;
                   if ( ( b.x == t.x ) && ( b.y == t.y ) )
                   {
                     if ( b.len < t.len )
                     {
                          t.sum = b.sum;
                          t.len = b.len;
                     }
                     if ( b.len == t.len )
                        if ( b.sum < t.sum )
                           t.sum = b.sum;
                   }
                   q.push( b );
                   o6te[b.x][b.y] = b.len;
                }
//                cout << b.x << " " << b.y << " " << o6te[b.x][b.y] << endl;
           }

           if ( stava( a.x-1, a.y ) )
           {
                b = flipdown( a );
                b.x = a.x-1;
                b.y = a.y;
                b.len = a.len + 1;
                b.sum = a.sum + b.down;
                {
                   sum[b.x][b.y] = b.sum;
                   if ( ( b.x == t.x ) && ( b.y == t.y ) )
                   {
                     if ( b.len < t.len )
                     {
                          t.sum = b.sum;
                          t.len = b.len;
                     }
                     if ( b.len == t.len )
                        if ( b.sum < t.sum )
                           t.sum = b.sum;
                   }
                   q.push( b );
                   o6te[b.x][b.y] = b.len;
                }
//                cout << b.x << " " << b.y << " " << o6te[b.x][b.y] << endl;
           }
           
           if ( stava( a.x, a.y-1 ) )
           {
                b = flipleft( a );
                b.x = a.x;
                b.y = a.y - 1;
                b.len = a.len + 1;
                b.sum = a.sum + b.down;
                {
                   sum[b.x][b.y] = b.sum;
                   if ( ( b.x == t.x ) && ( b.y == t.y ) )
                   {
                     if ( b.len < t.len )
                     {
                          t.sum = b.sum;
                          t.len = b.len;
                     }
                     if ( b.len == t.len )
                        if ( b.sum < t.sum )
                           t.sum = b.sum;
                   }
                   q.push( b );
                   o6te[b.x][b.y] = b.len;
                }
           }
        }
        
        for ( i = 1; i <= 26; i++ )
        {
            for ( j = 1; j <= 26; j++ )
                d[i][j] = o6te[i][j];
        }
//        for ( i = 1; i <= 26; i++ )
//        {
//            for ( j = 1; j <= 26; j++ )
//            {
//                if ( d[i][j] != -2 )
//                   cout << i << " " << j << " " << d[i][j] << endl;
//            }
//            cout << endl;
//        }
    }
    if ( t.len == INT_MAX )
         cout << "-1\n";
    else
        cout << t.sum << endl;
    return 0;
}
