#include<iostream>
#include<algorithm>
#include<cmath>
using namespace std;

const int ff=131072;
int ost[2*ff+1];
int dl[2*ff+1], dr[2*ff+1];
int p[2*ff+1];
int n, f;

inline int cmp(int i, int j)
{
  return dl[i]<dl[j];
}

inline int guests(int i, int j)
{
  if(ost[j]==0) return ost[i];
  int k=dr[j]-dl[i];
  //cout<<i<<' '<<j<<' '<<ost[i]<<' '<<ost[j]<<' '<<k<<endl;
  return min(ost[i], ost[j])+max(0, (abs(ost[i]-ost[j])-k)/2);
}

int main()
{
  cin>>n;
  int i; f=pow(2, ceil(log2(n)))-1;
  //cout<<f<<endl;
  for(i=0; i<n; i++) { scanf("%d%d", dl+f+i+1, ost+f+i+1); dr[f+i+1]=dl[f+i+1]; }
  for(i=f+1; i<f+n+1; i++) p[i]=i;
  sort(p+f+1, p+f+n+1, cmp);
  
  for(i=f; i>0; i--)
  {
    p[i]=i;
    ost[p[i]]=guests(p[2*i], p[2*i+1]);
    dl[p[i]]=dl[p[2*i]];
    dr[p[i]]=dr[p[2*i+1]];
    //cout<<ost[p[i]]<<endl;
  }
  cout<<ost[1]<<endl;
  return 0;
}