#include <iostream>
using namespace std;

unsigned long long N, M;

unsigned long long umnozh( unsigned long long a, unsigned long long b )
{
    int i, j, k;
    unsigned long long st, res = 0;
    
    st = a;
    while ( b > 0 )
    {
          if ( b % 2 == 1 )
               res = res + st;
          st = (2*st)%M;
          b = b/2;
    }
    return res;
}

void multiMatr( int n, int k, int p, unsigned long long a[][8], unsigned long long b[][8], unsigned long long c[][8] )
{
     int i, j, l;
     for ( i = 1; i <= n; i++ )
     {
         for ( j = 1; j <= p; j++ )
         {
             c[i][j] = 0;
             for ( l = 1; l <= k; l++ )
             {
                 c[i][j] = ( c[i][j] + umnozh( a[i][l], b[l][j] ) ) % M;
             }
         }
     }
}

void stepen( int n, unsigned long long a[][8], unsigned long long c[][8], unsigned long long st )
{
     int i, j, k, l;
     unsigned long long b[8][8], d[8][8];
     
     for ( i = 1; i <= n; i++ )
         for ( j = 1; j <= n; j++ )
         {
             b[i][j] = a[i][j];
             c[i][j] = 0;
         }
     for ( i = 1; i <= n; i++ )
         c[i][i] = 1;
     
     while ( st > 0 )
     {
           if ( st % 2 == 1 )
           {
                multiMatr( n, n, n, c, b, d );
                
                for ( i = 1; i <= n; i++ )
                {
                    for ( j = 1; j <= n; j++ )
                        c[i][j] = d[i][j];
                }
           }
           multiMatr( n, n, n, b, b, d );
           for ( i = 1; i <= n; i++ )
               for ( j = 1; j <= n; j++ )
                   b[i][j] = d[i][j];
           st = st / 2;
     }
}

int main()
{
    int i, j, k;
    unsigned long long m1[8][8], m2[8][8], m3[8][8];
    
    cin >> N >> M;
    m1[1][1] = 2; m1[1][2] = 1; m1[1][3] = 1;
    m1[2][1] = 1; m1[2][2] = 0; m1[2][3] = 0;
    m1[3][1] = 0; m1[3][2] = 1; m1[3][3] = 0;
    
    m3[1][1] = 2; m3[2][1] = 5; m3[3][1] = 12;
    
    if ( N > 3 )
    {
        stepen( 3, m1, m2, N-3 );
        multiMatr( 3, 3, 1, m2, m3, m1 );
        cout << ( m1[1][1] )%M << endl;
    }
    else
    {
        cout << m3[N][1] % M << endl;
    }
    
    return 0;
}
